package imo;

import java.awt.Graphics;
import java.awt.Image;

class Jiki extends Body {

    int hp;
    int hpMax;
    String name;

    int ShotWait;
    static final int ShotWaitMax = 15;

    boolean AnimeFlag;
    int AnimeWait;
    static final int AnimeWaitMax = 7;

    int Face;
    int Faces;
    static final int F_UP = 1;
    static final int F_DOWN = 2;
    static final int F_LEFT = 3;
    static final int F_RIGHT = 4;

    int Status;
    int StatusWait;
    static final int SwordWaitMax = 5;
    static final int DamageWaitMax = 3;
    static final int S_MOVE = 0;
    static final int S_SHOT = 1;
    static final int S_DAMAGE = 2;

    static final double V_WALK = 1.5;
    static final double V_DASH = 3;
    static final double V_DAMAGE = 5;

    boolean Life;
    Body screen;
    Image img;
    double oldx, oldy;

    Jiki( double x, double y, String name, Body screen, Image img ){
	super( x, y, 32, 32, 0, 1 );
	this.name = name;
	oldx = x;  oldy = y;
	hpMax = 10;
	hp = hpMax;
	ShotWait = 0;
	AnimeFlag = true;
	AnimeWait = 0;
	Face = 2;
	Faces = 2;
	Status = 0;
	StatusWait = 0;
	Life = true;
	this.screen = screen;
	this.img = img;
    }
	
    public void move( boolean u, boolean d, boolean l, boolean r ){
	ShotWait--;
	if( 0 >= StatusWait-- )  Status = S_MOVE;
	anime();

	oldx = x;  oldy = y;

	switch( Status ){
	case S_MOVE:
	case S_SHOT:
	    v = V_WALK;
	    moveK( Faces==1, Faces==2, Faces==3, Faces==4 );
	    Face = 0;
	    if( u )		Face = F_UP;
	    if( d )		Face = F_DOWN;
	    if( l )		Face = F_LEFT;
	    if( r )		Face = F_RIGHT;
	    if( Face != 0 )		Faces = Face;
	    v = V_DASH;
	    moveK( Face==1,  Face==2,  Face==3,  Face==4 );
	    moveC( screen );
	    break;
	case S_DAMAGE:
	    v = V_DAMAGE;
	    super.move();
	    break;
	default:
	}
    }
	
    public void moveS(){
	x = oldx;
	y = oldy;
    }		
		
    private void anime(){
	if( 0 >= AnimeWait-- ){
	    AnimeFlag = !AnimeFlag;
	    if( Face != 0 ) AnimeWait = AnimeWaitMax;
	    if( Face == 0 ) AnimeWait = AnimeWaitMax*2;
	}
    }

    public void shot( Sword sword ){
	if( ShotWait > 0 ) return;
	if( Status != S_MOVE ) return;
	sword.make( this, SwordWaitMax );
	ShotWait = ShotWaitMax;
	Status = S_SHOT;
	StatusWait = SwordWaitMax;
    }

    public void damage( Body teki, int d ){
	if( Status == S_DAMAGE ) return;
	Status = S_DAMAGE;
	StatusWait = DamageWaitMax;
	hp -= d;
	if( hp<0 ) hp=0;
	angle = getAngle( teki, this );
    }
			
    public void display( Graphics g ){
	int axs = (int)x;
	int ays = (int)y;
	int axf = axs + xs;
	int ayf = ays + ys;
	int bxs = 0;
	int bys = 0;
	switch( Faces ){
	case F_UP:		bxs += 32*6;	break;
	case F_DOWN:	bxs += 32*0;	break;
	case F_LEFT:	bxs += 32*2;	break;
	case F_RIGHT:	bxs += 32*4;	break;
	default:
	}
	if( AnimeFlag ) bxs += 32;
	switch( Status ){
	case S_MOVE:	bys += 32*0;	break;
	case S_DAMAGE:	bys += 32*1;	break;
	case S_SHOT:	bys += 32*2;	break;
	default:
	}
	int bxf = bxs + xs;
	int byf = bys + ys;
		
	g.drawImage( img, axs, ays, axf, ayf, bxs, bys, bxf, byf, null );
    }
	
    public void displayHP( Graphics g ){
	int axs = 72;
	int ays = 0;
	int axf = axs + 104;
	int ayf = ays + 32;
	int bxs = 0;
	int bys = 228;
	int bxf = bxs + 104;
	int byf = bys + 32;
	g.drawImage( img, axs, ays, axf, ayf, bxs, bys, bxf, byf, null );
	axs = 76;
	ays = 21;
	axf = axs + hp*96/hpMax;
	ayf = ays + 8;
	bxs = 4;
	bys = 267;
	bxf = bxs + hp*96/hpMax;
	byf = bys + 8;
	g.drawImage( img, axs, ays, axf, ayf, bxs, bys, bxf, byf, null );

	g.drawString(name, 72, 16);
    }
	
}
		
