package mine;

public abstract class RunCanvas extends JCanvas implements Runnable {

    Runner runner;

    /*** Constructer **************************************/

    public RunCanvas( int width, int height ){
	super( width, height );
	runner = new Runner(this);
    }
	
    /*** Start and Stop ************************************/

    public void start(){
	runner.start();
	requestFocus();
    }
	
    public void stop(){
	runner.stop();
    }

    /*** Sleep **********************************************/

    public void sleep( long msec ){
	runner.sleep(msec);
    }
}
