package imo;

import java.awt.Graphics;
import java.awt.Image;

class Sister extends Body {

    int hp;
    static final int hpMax = 3;
	
    boolean AnimeFlag;
    int AnimeWait;
    static final int AnimeWaitMax = 10;

    int Status;
    int StatusWait;
    static final int DamageWaitMax = 10;
    static final int S_NONE = 0;
    static final int S_DAMAGE = 1;
	
    boolean Life;
    Image img;
	
    Sister( double x, double y, Image img ){
	super( x, y, 32, 32, 0, 0 );
	hp = hpMax;
	AnimeFlag = true;
	AnimeWait = 0;
	Status = 0;
	StatusWait = 0;
	Life = true;
	this.img = img;
    }
	
    private void anime(){
	if( 0 >= StatusWait-- )  Status = S_NONE;
	if( 0 >= AnimeWait-- ){
	    AnimeFlag = !AnimeFlag;
	    AnimeWait = AnimeWaitMax;
	}
    }

    public void damage(){
	if( Status == S_DAMAGE ) return;
	Status = S_DAMAGE;
	StatusWait = DamageWaitMax;
	hp--;
    }
	
    public void move(){
	anime();
    }

    public void display( Graphics g ){
	int axs = (int)x;
	int ays = (int)y;
	int axf = axs + xs;
	int ayf = ays + ys;
	int bxs = 0;
	int bys = 32*6;
	if( AnimeFlag ) bxs += 32;
	if( Status == S_DAMAGE ) bxs += 64;
	int bxf = bxs + xs;
	int byf = bys + ys;
	g.drawImage( img, axs, ays, axf, ayf, bxs, bys, bxf, byf, null );
    }
}
